#include <stdio.h>
#include <stdlib.h>

union OneUnion
{
  char c;
  int i;
  float f;
};

struct Info
{
  char c;
  int i;
  float f;
};

union OneUnion test;
struct Info x;

int main(int argc, char *argv[]) {
	printf("size of union is %d\n", sizeof(test));
	// Don't worry about the wrong size of struct
	// This happens because of byte alignment 
	// for more info see the following url
	// https://en.wikipedia.org/wiki/Data_structure_alignment
	printf("size of struct is %d\n", sizeof( x ));
	printf("size of struct is %d\n", sizeof( char ) + sizeof(int) + sizeof(float));
	
	printf("\nAssign a char value\n");
	test.c = 'c';
	printf("char : %c\n", test.c);
	printf("int : %d\n", test.i);
	printf("float : %f\n", test.f);
	
	printf("\nAssign an integer value\n");

	test.i = 65;
	printf("char : %c\n", test.c);
	printf("int : %d\n", test.i);
	printf("float : %f\n", test.f);
	
	printf("\nAssign a float value\n");
	test.f = 24.53;
	printf("char : %c\n", test.c);
	printf("int : %d\n", test.i);
	printf("float : %f\n", test.f);
	
	return 0;
}


//struct InputEvent
//{
//	enum TypeOfEvent
//	{
//		KeyBoard, Mouse
//	} Type;
//	union 
//	{
//		unsigned int KeyboardKey;
//		struct {
//			int ScreenX;
//			int ScreenY;
//			int MouseKey;
//		} MouseEvent;
//	} Data;
//};
//
//
//
//int main(int argc, char *argv[]) {
//	struct InputEvent x;
//	x.Type = Mouse;
//	x.data.MouseEvent.ScreenX = 10;
//	x.data.MouseEvent.ScreenY = 20;
//	x.data.MouseEvent.MouseKey = 2;
//	
//	return 0;
//}


